diff --git a/cdist/conf/type/__filesystem/explorer/blkdev_devname b/cdist/conf/type/__filesystem/explorer/blkdev_devname
new file mode 100644
index 00000000..30c8409a
--- /dev/null
+++ b/cdist/conf/type/__filesystem/explorer/blkdev_devname
@@ -0,0 +1,38 @@
+#!/bin/sh
+#
+# 2016 - 2016 Daniel Heule (hda at sfs.biz)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+
+os=$("$__explorer/os")
+
+blkdev="$(cat "$__object/parameter/blkdev")"
+
+case "$os" in
+ centos|fedora|redhat|suse|gentoo)
+ if [ ! -x "$(command -v lsblk)" ]; then
+ echo "lsblk is required for __filesystem type" >&2
+ exit 1
+ else
+ echo -n $(lsblk -n -o NAME "$blkdev" 2>/dev/null)
+ fi
+ ;;
+ *)
+ echo "__filesystem type lacks implementation for os: $os" >&2
+ exit 1
+ ;;
+esac
diff --git a/cdist/conf/type/__filesystem/explorer/blkdev_fstype b/cdist/conf/type/__filesystem/explorer/blkdev_fstype
new file mode 100644
index 00000000..3f92142f
--- /dev/null
+++ b/cdist/conf/type/__filesystem/explorer/blkdev_fstype
@@ -0,0 +1,38 @@
+#!/bin/sh
+#
+# 2016 - 2016 Daniel Heule (hda at sfs.biz)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+
+os=$("$__explorer/os")
+
+blkdev="$(cat "$__object/parameter/blkdev")"
+
+case "$os" in
+ centos|fedora|redhat|suse|gentoo)
+ if [ ! -x "$(command -v lsblk)" ]; then
+ echo "lsblk is required for __filesystem type" >&2
+ exit 1
+ else
+ echo -n $(lsblk -n -o FSTYPE "$blkdev" 2>/dev/null)
+ fi
+ ;;
+ *)
+ echo "__filesystem type lacks implementation for os: $os" >&2
+ exit 1
+ ;;
+esac
diff --git a/cdist/conf/type/__filesystem/explorer/blkdev_label b/cdist/conf/type/__filesystem/explorer/blkdev_label
new file mode 100644
index 00000000..aa227cab
--- /dev/null
+++ b/cdist/conf/type/__filesystem/explorer/blkdev_label
@@ -0,0 +1,38 @@
+#!/bin/sh
+#
+# 2016 - 2016 Daniel Heule (hda at sfs.biz)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+
+os=$("$__explorer/os")
+
+blkdev="$(cat "$__object/parameter/blkdev")"
+
+case "$os" in
+ centos|fedora|redhat|suse|gentoo)
+ if [ ! -x "$(command -v lsblk)" ]; then
+ echo "lsblk is required for __filesystem type" >&2
+ exit 1
+ else
+ echo -n $(lsblk -n -o LABEL "$blkdev" 2>/dev/null)
+ fi
+ ;;
+ *)
+ echo "__filesystem type lacks implementation for os: $os" >&2
+ exit 1
+ ;;
+esac
diff --git a/cdist/conf/type/__filesystem/explorer/blkdev_mountpoint b/cdist/conf/type/__filesystem/explorer/blkdev_mountpoint
new file mode 100644
index 00000000..1cef068c
--- /dev/null
+++ b/cdist/conf/type/__filesystem/explorer/blkdev_mountpoint
@@ -0,0 +1,38 @@
+#!/bin/sh
+#
+# 2016 - 2016 Daniel Heule (hda at sfs.biz)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+
+os=$("$__explorer/os")
+
+blkdev="$(cat "$__object/parameter/blkdev")"
+
+case "$os" in
+ centos|fedora|redhat|suse|gentoo)
+ if [ ! -x "$(command -v lsblk)" ]; then
+ echo "lsblk is required for __filesystem type" >&2
+ exit 1
+ else
+ echo -n $(lsblk -n -o MOUNTPOINT "$blkdev" 2>/dev/null)
+ fi
+ ;;
+ *)
+ echo "__filesystem type lacks implementation for os: $os" >&2
+ exit 1
+ ;;
+esac
diff --git a/cdist/conf/type/__filesystem/gencode-remote b/cdist/conf/type/__filesystem/gencode-remote
new file mode 100644
index 00000000..9d134dcc
--- /dev/null
+++ b/cdist/conf/type/__filesystem/gencode-remote
@@ -0,0 +1,96 @@
+#!/bin/sh
+#
+# 2016 - 2016 Daniel Heule (hda at sfs.biz)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+
+
+fstype="$(cat "$__object/parameter/fstype")"
+mydev="$(cat "$__object/parameter/blkdev")"
+
+label="$(cat "$__object/parameter/label")"
+mkfsoptions="$(cat "$__object/parameter/mkfsoptions")"
+
+
+if [ -f "$__object/parameter/force" ]; then
+ # create filesystem even an other filesystem is on disk or the label is not correct, use with caution !
+ forcefs="true"
+else
+ forcefs="false"
+fi
+
+
+blkdev_devname="$(cat "$__object/explorer/blkdev_devname")"
+blkdev_fstype="$(cat "$__object/explorer/blkdev_fstype")"
+blkdev_label="$(cat "$__object/explorer/blkdev_label")"
+blkdev_mountpoint="$(cat "$__object/explorer/blkdev_mountpoint")"
+
+if [ -z "$blkdev_devname" ]; then
+ echo "Specified device $mydev not found on target system" >&2
+ exit 1
+fi
+
+[ "$blkdev_label" = "$label" ] && [ "$blkdev_fstype" = "$fstype" ] && exit 0
+
+if [ -n "$blkdev_mountpoint" ]; then
+ echo "Specified device $mydev is mounted on $blkdev_mountpoint, __filesystem does NOTHING with mountd devices" >&2
+ exit 0
+fi
+
+if [ -n "$blkdev_fstype" ] && [ "$forcefs" != "true" ]; then
+ if [ "$blkdev_label" != "$label" ]; then
+ echo "Specified device $mydev has not the spezified label: $blkdev_label, but __filesystem does NOTHING in this case without the --force option" >&2
+ exit 0
+ fi
+ if [ "$blkdev_fstype" != "$fstype" ]; then
+ echo "Specified device $mydev has not the spezified filesystem: $blkdev_fstype, but __filesystem does NOTHING in this case without the --force option" >&2
+ exit 0
+ fi
+fi
+
+
+# ok, all conditions checked, we need to format the device, lets go
+opts="$mkfsoptions"
+if [ -n "$label" ]; then
+ opts="$opts -L '$label'"
+fi
+
+case "$fstype" in
+ ext2|ext3|ext4)
+ if [ "$forcefs" = "true" ]; then
+ opts="$opts -F"
+ fi
+ echo "mkfs.$fstype $opts /dev/$blkdev_devname"
+ ;;
+ btrfs)
+ if [ "$forcefs" = "true" ]; then
+ opts="$opts --force"
+ fi
+ echo "mkfs.btrfs $opts /dev/$blkdev_devname"
+ ;;
+ xfs)
+ if [ "$forcefs" = "true" ]; then
+ opts="$opts -f"
+ fi
+ echo "mkfs.xfs $opts /dev/$blkdev_devname"
+ ;;
+ *)
+ echo "__filesystem type lacks implementation for filesystem: $fstype" >&2
+ exit 1
+ ;;
+esac
+echo "filesystem $fstype on $mydev : /dev/$blkdev_devname created" >> "$__messages_out"
diff --git a/cdist/conf/type/__filesystem/man.rst b/cdist/conf/type/__filesystem/man.rst
new file mode 100644
index 00000000..c4787d53
--- /dev/null
+++ b/cdist/conf/type/__filesystem/man.rst
@@ -0,0 +1,79 @@
+cdist-type__filesystem(7)
+=========================
+
+NAME
+----
+cdist-type__filesystem - Create Filesystems.
+
+
+DESCRIPTION
+-----------
+This cdist type allows you to create filesystems on devices.
+
+If the device is mounted on target, it refuses to do someting.
+
+If the device has a filesystem other as the specified and/or
+ the label is not correct, it only make a new filesystem
+ if you specified --force option
+
+
+REQUIRED PARAMETERS
+-------------------
+fstype
+ Filesystem type, for example 'ext3', 'btrfs' or 'xfs'
+
+blkdev
+ Blockdevice for filesystem,
+ On linux, it can be any by lsblk accepted device notation
+
+ for example
+ /dev/sdx
+ or /dev/disk/by-xxxx/xxx
+ or /dev/mapper/xxxx
+
+
+OPTIONAL PARAMETERS
+-------------------
+label
+ Label which sould apply on the filesystem
+
+mkfsoptions
+ Additional options which are inserted to the mkfs.xxx call.
+
+
+BOOLEAN PARAMETERS
+------------------
+force
+ Normaly, this type does nothing if a filesystem is found
+ on the target device. If you specify force, its formated
+ if the filesystem type or label differs from parameters
+ Warning: This option can easy lead into data loss !
+
+MESSAGES
+--------
+filesystem on : created
+ Filesytem was created on
+
+
+EXAMPLES
+--------
+
+.. code-block:: sh
+
+ # Ensures that device /dev/sdb is formated with xfs
+ __filesystem dev_sdb --fstype xfs --blkdev /dev/sdb --label Testdisk1
+ # The same thing with btrfs and disk spezified by pci path to disk 1:0 on vmware
+ __filesystem dev_sdb --fstype btrfs --blkdev /dev/disk/by-path/pci-0000:0b:00.0-scsi-0:0:0:0 --label Testdisk2
+ # Make sure that a multipath san device has a filesystem ...
+ __filesystem dev_sdb --fstype xfs --blkdev /dev/mapper/360060e80432f560050202f22000023ff --label Testdisk3
+
+
+AUTHORS
+-------
+Daniel Heule
+
+
+COPYING
+-------
+Copyright \(C) 2016 Daniel Heule. Free use of this software is
+granted under the terms of the GNU General Public License version 3 or any later version (GPLv3+).
diff --git a/cdist/conf/type/__filesystem/parameter/boolean b/cdist/conf/type/__filesystem/parameter/boolean
new file mode 100644
index 00000000..14b33226
--- /dev/null
+++ b/cdist/conf/type/__filesystem/parameter/boolean
@@ -0,0 +1 @@
+force
diff --git a/cdist/conf/type/__filesystem/parameter/default/label b/cdist/conf/type/__filesystem/parameter/default/label
new file mode 100644
index 00000000..e69de29b
diff --git a/cdist/conf/type/__filesystem/parameter/default/mkfsoptions b/cdist/conf/type/__filesystem/parameter/default/mkfsoptions
new file mode 100644
index 00000000..e69de29b
diff --git a/cdist/conf/type/__filesystem/parameter/optional b/cdist/conf/type/__filesystem/parameter/optional
new file mode 100644
index 00000000..0f63435f
--- /dev/null
+++ b/cdist/conf/type/__filesystem/parameter/optional
@@ -0,0 +1,2 @@
+label
+mkfsoptions
diff --git a/cdist/conf/type/__filesystem/parameter/required b/cdist/conf/type/__filesystem/parameter/required
new file mode 100644
index 00000000..33a66684
--- /dev/null
+++ b/cdist/conf/type/__filesystem/parameter/required
@@ -0,0 +1,2 @@
+fstype
+blkdev
diff --git a/docs/changelog b/docs/changelog
index f73ba776..ba8ee201 100644
--- a/docs/changelog
+++ b/docs/changelog
@@ -1,5 +1,7 @@
Changelog
---------
+next:
+ * New type __filesystem: manage filesystems on devices ( Daniel Heule )
4.2.2: 2016-07-26
* Core: Fix ssh ControlPath socket file error (Darko Poljak)